
vonn={}
function vonn.print(msg) print(msg) log(msg) if not game.is_multiplayer() then game.print(msg,{r=255,g=255}) end end


function vonn.createEntity(options)
	if type(options.name)~="string" then error("no name: "..type(options.name))
	elseif type(options.position)~="table" then error("no position: "..type(options.position))
	end

	local entity = game.surfaces[options.surface or "nauvis"].create_entity{ name=options.name, position=options.position, force=options.force or "player" }

	entity.destructible = options.destructible or true
	entity.minable = options.minable or true
	entity.rotatable = options.rotatable or true
	entity.operable = not (options.inoperable or false)

	return entity
end

function vonn.createSiteChest(options,items)
	local e=vonn.createEntity(options)
	for k,v in pairs(items)do e.insert({name=k,count=v}) end
	return e
end
function vonn.createSiteGenerator(pos)
	local e=vonn.createEntity{name="crash-site-generator",position=pos,inoperable=true}
	e.power_production = "15000"
	e.electric_buffer_size  = "100000000"
	return e
end

function vonn.SummonCrashSite()
	if(global.donecrashsite)then return end
	global.donecrashsite=true
	local electricEnergyInterface = vonn.createSiteGenerator({0,0})
	local crashSiteLab = vonn.createEntity{name="crash-site-lab-repaired",position={0,4}}
	local crashSiteAssemblingMachine1 = vonn.createEntity{name="crash-site-assembling-machine-1-repaired",position={5,0}}
	local crashSiteAssemblingMachine2 = vonn.createEntity{name="crash-site-assembling-machine-2-repaired",position={6,4}}
	local items1 = {
		coal=1,
		['small-electric-pole']=4,
		['burner-mining-drill']=3,
		['stone-furnace']=2,
		['firearm-magazine']=10,
		['gun-turret']=1,
		['burner-inserter']=2,
		['inserter']=2,
		['compilatron-chest']=1,
		['assembling-machine-1']=2,
	}
	local crashSiteChest1 = vonn.createSiteChest({name="crash-site-chest-1",position={8,7}},items1)
	local items2 = {
		roboport=3,
		['construction-robot']=100,
		['logistic-robot']=100,
		['flying-robot-frame']=100,
		['logistic-chest-active-provider']=10,
		['logistic-chest-buffer']=2,
		['logistic-chest-passive-provider']=2,
		['logistic-chest-requester']=2,
		['logistic-chest-storage']=10,
	}
	local crashSiteChest2 = vonn.createSiteChest({name="crash-site-chest-2",position={-3,-3}},items2)
end

function vonn.NewPlayer(event)
	local idx=event.player_index
	local p=game.players[idx]
	if(p.character)then p.character.destroy() p.character=nil end
	vonn.apply_bonuses()
end

script.on_event({
defines.events.on_player_joined_game,
defines.events.on_player_created,
defines.events.on_player_respawned,
--defines.events.on_player_left_game,
--defines.events.on_player_changed_force,
--defines.events.on_player_removed,
--defines.events.on_pre_player_left_game,
}, vonn.NewPlayer)

function vonn.apply_bonuses()
	game.forces.player.character_build_distance_bonus = 125
	game.forces.player.character_reach_distance_bonus = 125
	game.forces.player.character_resource_reach_distance_bonus = 7
	game.forces.player.character_item_pickup_distance_bonus = 7
	for i,player in pairs(game.players)do player.game_view_settings.show_rail_block_visualisation = true end

	for k,v in pairs(game.players)do if(v.character)then v.character.destroy() v.character=nil end end
end


function vonn.on_init() vonn.apply_bonuses() vonn.SummonCrashSite() end
script.on_init(vonn.on_init)
